commit eed2f8c3a99ef080b798947ff5b4c83e7a111919
Author: Daniel P. Berrange <berrange@redhat.com>
Date:   Tue Feb 2 17:22:03 2010 +0000

    Change the internal domain conf representation of localtime/utc
    
    The XML will soon be extended to allow more than just a simple
    localtime/utc boolean flag. This change replaces the plain
    'int localtime' with a separate struct to prepare for future
    extension
    
    * src/conf/domain_conf.c, src/conf/domain_conf.h: Add a new
      virDomainClockDef structure
    * src/libvirt_private.syms: Export virDomainClockOffsetTypeToString
      and virDomainClockOffsetTypeFromString
    * src/qemu/qemu_conf.c, src/vbox/vbox_tmpl.c, src/xen/xend_internal.c,
      src/xen/xm_internal.c: Updated to use new structure for localtime

Index: libvirt-0.7.6/src/conf/domain_conf.c
===================================================================
--- libvirt-0.7.6.orig/src/conf/domain_conf.c
+++ libvirt-0.7.6/src/conf/domain_conf.c
@@ -231,6 +231,10 @@ VIR_ENUM_IMPL(virDomainSeclabel, VIR_DOM
               "dynamic",
               "static")
 
+VIR_ENUM_IMPL(virDomainClockOffset, VIR_DOMAIN_CLOCK_OFFSET_LAST,
+              "utc",
+              "localtime");
+
 #define virDomainReportError(conn, code, fmt...)                           \
         virReportErrorHelper(conn, VIR_FROM_DOMAIN, code, __FILE__,        \
                                __FUNCTION__, __LINE__, fmt)
@@ -3492,9 +3496,16 @@ static virDomainDefPtr virDomainDefParse
 
 
     tmp = virXPathString(conn, "string(./clock/@offset)", ctxt);
-    if (tmp && STREQ(tmp, "localtime"))
-        def->localtime = 1;
-    VIR_FREE(tmp);
+    if (tmp) {
+        if ((def->clock.offset = virDomainClockOffsetTypeFromString(tmp)) < 0) {
+            virDomainReportError(conn, VIR_ERR_INTERNAL_ERROR,
+                                 _("unknown clock offset '%s'"), tmp);
+            goto error;
+        }
+        VIR_FREE(tmp);
+    } else {
+        def->clock.offset = VIR_DOMAIN_CLOCK_OFFSET_UTC;
+    }
 
     def->os.bootloader = virXPathString(conn, "string(./bootloader)", ctxt);
     def->os.bootloaderArgs = virXPathString(conn, "string(./bootloader_args)", ctxt);
@@ -5538,7 +5549,7 @@ char *virDomainDefFormat(virConnectPtr c
         goto cleanup;
 
     virBufferVSprintf(&buf, "  <clock offset='%s'/>\n",
-                      def->localtime ? "localtime" : "utc");
+                      virDomainClockOffsetTypeToString(def->clock.offset));
 
     if (virDomainLifecycleDefFormat(conn, &buf, def->onPoweroff,
                                     "on_poweroff",
Index: libvirt-0.7.6/src/conf/domain_conf.h
===================================================================
--- libvirt-0.7.6.orig/src/conf/domain_conf.h
+++ libvirt-0.7.6/src/conf/domain_conf.h
@@ -605,6 +605,19 @@ struct _virSecurityLabelDef {
     int type;
 };
 
+enum virDomainClockOffsetType {
+    VIR_DOMAIN_CLOCK_OFFSET_UTC = 0,
+    VIR_DOMAIN_CLOCK_OFFSET_LOCALTIME = 1,
+
+    VIR_DOMAIN_CLOCK_OFFSET_LAST,
+};
+
+typedef struct _virDomainClockDef virDomainClockDef;
+typedef virDomainClockDef *virDomainClockDefPtr;
+struct _virDomainClockDef {
+    int offset;
+};
+
 #define VIR_DOMAIN_CPUMASK_LEN 1024
 
 /* Guest VM main configuration */
@@ -633,7 +646,7 @@ struct _virDomainDef {
     char *emulator;
     int features;
 
-    int localtime;
+    virDomainClockDef clock;
 
     int ngraphics;
     virDomainGraphicsDefPtr *graphics;
@@ -941,5 +954,6 @@ VIR_ENUM_DECL(virDomainGraphics)
 /* from libvirt.h */
 VIR_ENUM_DECL(virDomainState)
 VIR_ENUM_DECL(virDomainSeclabel)
+VIR_ENUM_DECL(virDomainClockOffset)
 
 #endif /* __DOMAIN_CONF_H */
Index: libvirt-0.7.6/src/libvirt_private.syms
===================================================================
--- libvirt-0.7.6.orig/src/libvirt_private.syms
+++ libvirt-0.7.6/src/libvirt_private.syms
@@ -197,6 +197,8 @@ virDomainDefClearPCIAddresses;
 virDomainDefClearDeviceAliases;
 virDomainDeviceInfoIterate;
 virDomainDiskDefForeachPath;
+virDomainClockOffsetTypeToString;
+virDomainClockOffsetTypeFromString;
 
 
 # domain_event.h
Index: libvirt-0.7.6/src/qemu/qemu_conf.c
===================================================================
--- libvirt-0.7.6.orig/src/qemu/qemu_conf.c
+++ libvirt-0.7.6/src/qemu/qemu_conf.c
@@ -3380,8 +3380,14 @@ int qemudBuildCommandLine(virConnectPtr
         }
     }
 
-    if (def->localtime)
+    if (def->clock.offset == VIR_DOMAIN_CLOCK_OFFSET_LOCALTIME)
         ADD_ARG_LIT("-localtime");
+    else if (def->clock.offset != VIR_DOMAIN_CLOCK_OFFSET_UTC) {
+        qemudReportError(conn, NULL, NULL, VIR_ERR_CONFIG_UNSUPPORTED,
+                        _("unsupported clock offset '%s'"),
+                        virDomainClockOffsetTypeToString(def->clock.offset));
+        goto error;
+    }
 
     if ((qemuCmdFlags & QEMUD_CMD_FLAG_NO_REBOOT) &&
         def->onReboot != VIR_DOMAIN_LIFECYCLE_RESTART)
@@ -5195,6 +5201,7 @@ virDomainDefPtr qemuParseCommandLine(vir
     def->id = -1;
     def->memory = def->maxmem = 64 * 1024;
     def->vcpus = 1;
+    def->clock.offset = VIR_DOMAIN_CLOCK_OFFSET_UTC;
     def->features = (1 << VIR_DOMAIN_FEATURE_ACPI)
         /*| (1 << VIR_DOMAIN_FEATURE_APIC)*/;
     def->onReboot = VIR_DOMAIN_LIFECYCLE_RESTART;
@@ -5374,7 +5381,7 @@ virDomainDefPtr qemuParseCommandLine(vir
         } else if (STREQ(arg, "-full-screen")) {
             fullscreen = 1;
         } else if (STREQ(arg, "-localtime")) {
-            def->localtime = 1;
+            def->clock.offset = VIR_DOMAIN_CLOCK_OFFSET_LOCALTIME;
         } else if (STREQ(arg, "-kernel")) {
             WANT_VALUE();
             if (!(def->os.kernel = strdup(val)))
Index: libvirt-0.7.6/src/vbox/vbox_tmpl.c
===================================================================
--- libvirt-0.7.6.orig/src/vbox/vbox_tmpl.c
+++ libvirt-0.7.6/src/vbox/vbox_tmpl.c
@@ -2051,7 +2051,7 @@ static char *vboxDomainDumpXML(virDomain
 
             /* Currently VirtualBox always uses locatime
              * so locatime is always true here */
-            def->localtime = 1;
+            def->clock.offset = VIR_DOMAIN_CLOCK_OFFSET_LOCALTIME;
 
             /* dump video options vram/2d/3d/directx/etc. */
             {
Index: libvirt-0.7.6/src/xen/xend_internal.c
===================================================================
--- libvirt-0.7.6.orig/src/xen/xend_internal.c
+++ libvirt-0.7.6/src/xen/xend_internal.c
@@ -2468,7 +2468,7 @@ xenDaemonParseSxpr(virConnectPtr conn,
     } else
         def->onCrash = VIR_DOMAIN_LIFECYCLE_DESTROY;
 
-
+    def->clock.offset = VIR_DOMAIN_CLOCK_OFFSET_UTC;
     if (hvm) {
         if (sexpr_int(root, "domain/image/hvm/acpi"))
             def->features |= (1 << VIR_DOMAIN_FEATURE_ACPI);
@@ -2479,12 +2479,12 @@ xenDaemonParseSxpr(virConnectPtr conn,
 
         /* Old XenD only allows localtime here for HVM */
         if (sexpr_int(root, "domain/image/hvm/localtime"))
-            def->localtime = 1;
+            def->clock.offset = VIR_DOMAIN_CLOCK_OFFSET_LOCALTIME;
     }
 
     /* Current XenD allows localtime here, for PV and HVM */
     if (sexpr_int(root, "domain/localtime"))
-        def->localtime = 1;
+        def->clock.offset = VIR_DOMAIN_CLOCK_OFFSET_LOCALTIME;
 
     if (sexpr_node_copy(root, hvm ?
                         "domain/image/hvm/device_model" :
@@ -5866,8 +5866,14 @@ xenDaemonFormatSxpr(virConnectPtr conn,
     virBufferVSprintf(&buf, "(on_crash '%s')", tmp);
 
     /* Set localtime here for current XenD (both PV & HVM) */
-    if (def->localtime)
+    if (def->clock.offset == VIR_DOMAIN_CLOCK_OFFSET_LOCALTIME)
         virBufferAddLit(&buf, "(localtime 1)");
+    else if (def->clock.offset != VIR_DOMAIN_CLOCK_OFFSET_UTC) {
+        virXendError(conn, VIR_ERR_CONFIG_UNSUPPORTED,
+                     _("unsupported clock offset '%s'"),
+                     virDomainClockOffsetTypeToString(def->clock.offset));
+        goto error;
+    }
 
     if (!def->os.bootloader) {
         if (STREQ(def->os.type, "hvm"))
@@ -5985,7 +5991,7 @@ xenDaemonFormatSxpr(virConnectPtr conn,
             }
 
             /* Set localtime here to keep old XenD happy for HVM */
-            if (def->localtime)
+            if (def->clock.offset == VIR_DOMAIN_CLOCK_OFFSET_LOCALTIME)
                 virBufferAddLit(&buf, "(localtime 1)");
 
             if (def->sounds) {
Index: libvirt-0.7.6/src/xen/xm_internal.c
===================================================================
--- libvirt-0.7.6.orig/src/xen/xm_internal.c
+++ libvirt-0.7.6/src/xen/xm_internal.c
@@ -683,6 +683,7 @@ xenXMDomainConfigParse(virConnectPtr con
     virDomainHostdevDefPtr hostdev = NULL;
     int i;
     const char *defaultArch, *defaultMachine;
+    int vmlocaltime = 0;
 
     if (VIR_ALLOC(def) < 0) {
         virReportOOMError(conn);
@@ -830,9 +831,13 @@ xenXMDomainConfigParse(virConnectPtr con
         else if (val)
             def->features |= (1 << VIR_DOMAIN_FEATURE_APIC);
     }
-    if (xenXMConfigGetBool(conn, conf, "localtime", &def->localtime, 0) < 0)
+    if (xenXMConfigGetBool(conn, conf, "localtime", &vmlocaltime, 0) < 0)
         goto cleanup;
 
+    def->clock.offset = vmlocaltime ?
+        VIR_DOMAIN_CLOCK_OFFSET_LOCALTIME :
+        VIR_DOMAIN_CLOCK_OFFSET_UTC;
+
     if (xenXMConfigCopyStringOpt(conn, conf, "device_model", &def->emulator) < 0)
         goto cleanup;
 
@@ -2325,8 +2330,18 @@ virConfPtr xenXMDomainConfigFormat(virCo
             goto no_memory;
 
 
-        if (xenXMConfigSetInt(conf, "localtime", def->localtime ? 1 : 0) < 0)
-            goto no_memory;
+        if (def->clock.offset == VIR_DOMAIN_CLOCK_OFFSET_LOCALTIME ||
+            def->clock.offset == VIR_DOMAIN_CLOCK_OFFSET_UTC) {
+            if (xenXMConfigSetInt(conf, "localtime",
+                                  def->clock.offset == VIR_DOMAIN_CLOCK_OFFSET_LOCALTIME ?
+                                  1 : 0) < 0)
+                goto no_memory;
+        } else {
+            xenXMError(conn, VIR_ERR_CONFIG_UNSUPPORTED,
+                       _("unsupported clock offset '%s'"),
+                       virDomainClockOffsetTypeToString(def->clock.offset));
+            goto cleanup;
+        }
 
         if (priv->xendConfigVersion == 1) {
             for (i = 0 ; i < def->ndisks ; i++) {